#define MAP_FILE_VERSION	2

var
{
	mapname
	mapdesc
	mapangle = 270
	maplaps = 5

}

world
{
	turf = /turf/grass
	loop_checks = 1
	view = 10
}

mob
{
	verb
	{
		SetName(name as text)
		{
			mapname = name
		}

		SetDescription(desc as message)
		{
			mapdesc = desc
		}

		SetDefaultLaps(laps as num)
		{
			maplaps = laps
		}
		SetStartingAngle(angle as num)
		{
			mapangle = angle
		}
		Save(name as text)
		{
			SaveMap(name)
		}

		Load(name as file)
		{
			LoadMap(name)
		}
	}

	Stat()
	{
		statpanel("Map Info")
		stat("Map name",mapname)
		stat("Map description",mapdesc)
		stat("Default laps",maplaps)
		stat("Start Angle",mapangle)
	}
}

turf
{
	proc
	{
		Save(savefile/S)
		{

		}

		Load(savefile/S)
		{

		}
	}

	track
	{
		icon = 'track.dmi'

		Refuel
		{
			icon = 'refuel.dmi'
		}

		yellowline
		{
			icon = 'yellowlinedroad.dmi'

			Save(savefile/S)
			{
				S << icon_state
			}

			Load(savefile/S)
			{
				S >> icon_state
			}
		}

		whiteline
		{
			icon = 'whitelinedroad.dmi'

			Save(savefile/S)
			{
				S << icon_state
			}

			Load(savefile/S)
			{
				S >> icon_state
			}
		}

		wall
		{
			icon = 'wall.dmi'
		}

		checkpoint
		{
			var/checknum = 1
			icon = 'checkpoint.dmi'

			Save(savefile/S)
			{
				S << checknum
			}

			Load(savefile/S)
			{
				S >> checknum
			}
		}

		start
		{
			icon = 'start.dmi'
		}

		finish
		{
			icon = 'start.dmi'
		}

	}

	grass
	{
		icon = 'grass.dmi'
	}

	water
	{
		icon = 'water.dmi'
	}
}

proc
{
	SaveMap(sname)
	{
		var
		{
			i
			j
			k
			turf/T
		}
		fdel(sname)
		var/savefile/S = new(sname)
		S << world.maxx
		S << world.maxy
		S << world.maxz
		S << mapangle
		S << maplaps
		S << mapname
		S << mapdesc
		for(i = 1; i < world.maxx + 1; i++)
			for(j = 1; j < world.maxy + 1; j++)
				for(k = 1; k < world.maxz + 1; k++)
					T = locate(i,j,k)
					S << T.type
					T.Save(S)
	}

	LoadMap(sname)
	{
		var
		{
			i
			j
			k
			ty
			turf/T
		}

		var/savefile/S = new(sname)
		S >> world.maxx
		S >> world.maxy
		S >> world.maxz
		S >> mapangle
		S >> maplaps
		S >> mapname
		S >> mapdesc

		for(i = 1; i < world.maxx + 1; i++)
			for(j = 1; j < world.maxy + 1; j++)
				for(k = 1; k < world.maxz + 1; k++)
					S >> ty
					T = new ty(locate(i,j,k))
					T.Load(S)
	}
}